-- SMB2 Lua script by SpiderDave
--
--2012.03.09
--
-- Changes:
--  * Change character in game by pressing select
-- ToDo/Issues/Bugs:
--  * Pressing select when not in game can cause undesired effects, such as
--    distorted graphics, wrong palette.
--  * Luigi gravity isn't quite perfect
--  * Some things may not change when switching, like root holding position.
--  * Character switching can be abused in some ways, like continuing a 
--    princess float with another character, or switching mid-jump with toad
--    to get a higher jump with Luigi.  A good fix would be to make switching
--    only possible on the ground, or have switching cancel a jump.
--

require ".\\SpiderDave\\SpiderDave_functions"

function setcharacter(cnum)
	memory.writebyte(0x008f,cnum) --character
	if memory.readbyte(0x06f9)>=4 then small=4 else small=0 end
	
	--[[
	memory.writebyte(0x06f9,0x00+small) --character appearance
	memory.writebytes(0x0638,hex2bin('011627')) --palette
	memory.writebyte(0x054d,0xb0) --standing jump height
	memory.writebyte(0x054e,152) --Crouching power jump height
	memory.writebyte(0x0553,0x00) --Float Timer
	memory.writebyte(0x0554,0x07) --Gravity
	memory.writebyte(0x0555,0x04) --Gravity (jump)
	memory.writebyte(0x0556,0x08) --Gravity (sand)
	memory.writebyte(0x0550,166) --Running Jump height
	memory.writebyte(0x0551,170) --Running Jump height with object
	]]--
	
	if cnum==0 then
		--Mario
		memory.writebytes(0x0546,hex2bin('000402010407b0b09898a6aae000070408')) --stats
		memory.writebyte(0x06f9,0x00+small) --character appearance
		memory.writebytes(0x0638,hex2bin('011627')) --palette
	elseif cnum==1 then
		--Princess
		memory.writebytes(0x0546,hex2bin('00060402060cb3b39898acb3e03c070408')) --stats
		memory.writebyte(0x06f9,0x02+small) --character appearance
		memory.writebytes(0x0638,hex2bin('062536')) --palette
	elseif cnum==2 then
		--Toad
		memory.writebytes(0x0546,hex2bin('000101010102b2b29898adade000070408')) --stats
		memory.writebyte(0x06f9,0x03+small) --character appearance
		memory.writebytes(0x0638,hex2bin('013027')) --palette
	elseif cnum==3 then
		--Luigi
		memory.writebytes(0x0546,hex2bin('000402010407d6d6c9c9d0d4e000020108')) --stats
		memory.writebyte(0x06f9,0x01+small) --character appearance
		memory.writebytes(0x0638,hex2bin('012a36')) --palette
	end
	
	--Refresh palette stuff
	memory.writebyteppu(0x3f00+0x11+0,memory.readbyte(0x0638+0))
	memory.writebyteppu(0x3f00+0x11+1,memory.readbyte(0x0638+1))
	memory.writebyteppu(0x3f00+0x11+2,memory.readbyte(0x0638+2))
end

while (true) do
	inp = input_read()
	joy = joypad_read()
	
	if joy[1].select_press then
		setcharacter((memory.readbyte(0x008f)+1)%4)
	end
	
	FCEU.frameadvance();
end;